<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { storeToRefs } from 'pinia';
import { watch, ref, inject} from 'vue';
import BoxSelector, { type item } from '@/components/general/form/BoxSelector.vue';
import { itemEnum, userType } from '@/enums/enums';
import { useScheduleStore } from '@/stores/schedule';
import Modal from '@/components/general/Modal.vue';
import IconButton from '@/components/general/IconButton.vue';
import ColorSwatch from '@/components/general/form/ColorSwatch.vue';
import Dropdown from '@/components/general/Dropdown.vue';
import useSchedule from '@/hooks/useSchedule';

const props = defineProps<{
    color: string,
    shape: string,
    postIndex: number,
    columnIndex: number
    post: any,
    postCount: number,
    columnCount: number
}>();

const emits = defineEmits<{
    (e: 'edit'): void
}>();

const elementColor = ref(props.color);
const elementShape = ref(props.shape);

watch(() => props.color, (color) => {
    elementColor.value = color;
});

watch(() => props.shape, (shape) => {
    elementShape.value = shape;
});

let store: any = useScheduleStore();
let { deletePost: deletePostHook } = useSchedule();

const { getFullUsable, getDeletable, getMovable, getStyle, getUserType } = storeToRefs(store);
const configuration = inject<any>('configuration');
let elementColors: item[] = configuration.style.commentColors;
let shapes: item[] = configuration.style.shapes;

const changeColor = (close: () => void) => {
    close();
    store.editPostProps({ postIndex: props.postIndex, columnIndex: props.columnIndex, color: elementColor.value });
}

const changeShape = (close: () => void) => {
    close();
    store.editPostProps({ postIndex: props.postIndex, columnIndex: props.columnIndex, shape: elementShape.value });
}

const changeVisibility = (value: boolean, close: () => void) => {
    close();
    store.editPostProps({ postIndex: props.postIndex, columnIndex: props.columnIndex, visible: value });
}

const editPost = (close: () => void) => {
    close();
    setTimeout(() => {
        emits('edit');
    }, 10);
}

const copyPost = (close: () => void) => {
    close();
    store.createPost({ title: props.post.title.headline, text: props.post.title.post, body: props.post.body, info: props.post.info, columnIndex: props.columnIndex, index: props.postIndex + 1 });
}

const deletePost = () => {
    deletePostHook({ postIndex: props.postIndex, columnIndex: props.columnIndex });
    showDeleteModal(false);
}

const movePostYAxis = (direction: string, close: () => void) => {
    close();
    store.editPostPosition({ postIndex: props.postIndex, columnIndex: props.columnIndex, direction: direction });
}

const movePostXAxis = (newColumnIndex: number, close: () => void) => {
    close();
    store.editPostPosition({ postIndex: props.postIndex, columnIndex: props.columnIndex, newColumnIndex: newColumnIndex });
}

const isDeleteModalOpen = ref(false);
const showDeleteModal = (value: boolean) => {
    isDeleteModalOpen.value = value;
}
const openDeleteModal = (close: () => void) => {
    close();
    setTimeout(() => {
        showDeleteModal(true);
    });
}

</script>
<template>
    <Dropdown>
        <template #button>
            <Tooltip :tooltip="$t('tooltips.settings')">
                <button class="hover:bg-gray-100 px-1 rounded-md text-lg">
                    <strong><i class="ri-more-line"></i></strong>
                </button>
            </Tooltip>
        </template>
        <template v-slot="{ close }">
            <div class="flex flex-col gap-2">
                <div class="flex flex-col gap-1">
                    <BoxSelector v-model="elementColor" :items="elementColors" :identifier="itemEnum.VALUE"
                        type="colors" @click="changeColor(close)" />
                    <ColorSwatch v-model="elementColor" :onChange="() => changeColor(close)" />
                </div>
                <div class="border border-gray-200"></div>
                <div class="">
                    <BoxSelector v-model="elementShape" :items="shapes" :identifier="itemEnum.ID" type="shapes"
                        @click="changeShape(close)" />
                </div>
                <div class="border border-gray-200" v-if="getFullUsable || getDeletable"></div>
                <div>
                    <label v-if="getFullUsable || getDeletable">{{ $t('contentPage.editLabel') }}</label>
                    <div class="flex flex-row">
                        <div class="w-full">
                            <IconButton icon="pencil" :tooltip="$t('contentPage.editLabel')" @click="editPost(close)"
                                color="text-blue-700" v-if="getFullUsable" />
                        </div>
                        <div class="w-full">
                            <IconButton icon="file-copy" :tooltip="$t('contentPage.copyLabel')" @click="copyPost(close)"
                                color="text-cyan-500"
                                v-if="getFullUsable && post && ((post.body && post.body.type !== 'file') || !post.body)" />
                        </div>
                        <div class="w-full">
                            <IconButton icon="delete-bin" :tooltip="$t('contentPage.deleteLabel')" color="text-red-700"
                                @click="openDeleteModal(close)" v-if="getDeletable" />
                        </div>
                    </div>
                </div>
                <div class="border border-gray-200" v-if="getMovable && (postIndex > 0 || postIndex < postCount - 1 || columnIndex > 0 || columnIndex <
            columnCount - 1)">
                </div>
            </div>
            <div
                v-if="getMovable && (postIndex > 0 || postIndex < postCount - 1 || columnIndex > 0 || columnIndex < columnCount - 1)">
                <label>{{ $t('contentPage.moveLabel') }}</label>
                <div class="flex flex-row" v-if="getMovable">
                    <div class="w-full">
                        <IconButton icon="arrow-up" :tooltip="$t('contentPage.move.up')"
                            @click="movePostYAxis('-1', close)" color="text-yellow-600"
                            v-if="getMovable && postIndex > 0" />
                    </div>
                    <div class="w-full">
                        <IconButton icon="arrow-down" :tooltip="$t('contentPage.move.down')" color="text-orange-600"
                            @click="movePostYAxis('+1', close)" co v-if="getMovable && postIndex < (postCount - 1)" />
                    </div>
                    <div class="w-full">
                        <IconButton icon="arrow-left" :tooltip="$t('contentPage.move.left')" color="text-fuchsia-700"
                            @click="movePostXAxis(columnIndex - 1, close)" v-if="getMovable && columnIndex > 0" />
                    </div>
                    <div class="w-full">
                        <IconButton icon="arrow-right" :tooltip="$t('contentPage.move.right')" color="text-violet-700"
                            @click="movePostXAxis(columnIndex + 1, close)"
                            v-if="getMovable && columnIndex < columnCount - 1" />
                    </div>
                </div>
            </div>
            <div class="border border-gray-200"
                v-if="getUserType === userType.ADMIN || getUserType === userType.MODERATOR"></div>
            <div v-if="getUserType === userType.ADMIN || getUserType === userType.MODERATOR">
                <label>{{ $t('contentPage.hideLabel') }}</label>
                <div class="flex flex-row">
                    <div class="w-full">
                        <IconButton icon="eye" :tooltip="$t('tooltips.hide')" @click="changeVisibility(false, close)"
                            color="text-sky-500" v-if="props.post.visible" />
                    </div>
                    <div class="w-full">
                        <IconButton icon="eye-off" :tooltip="$t('tooltips.unhide')"
                            @click="changeVisibility(true, close)" v-if="!props.post.visible" color="text-teal-500" />
                    </div>
                </div>
            </div>
        </template>
    </Dropdown>
    <Modal :labelSubmit="$t('adminMenu.pageDelete.submit')" :labelCancel="$t('general.buttons.cancel')"
        @submit="deletePost" @cancel="showDeleteModal(false)" :text="$t('contentPage.post.deletePost')"
        :font="getStyle?.font ? getStyle.font : ''" v-if="isDeleteModalOpen"></Modal>
</template>